
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class System_parametersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const system_parameters = await db.system_parameters.create(
            {
                id: data.id || undefined,
        
        key: data.key
        ||
        null
            ,
            
        value: data.value
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        lastUpdatedAt: data.lastUpdatedAt
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await system_parameters.setLastUpdatedByUser( data.lastUpdatedByUser || null, {
            transaction,
        });
        

        

        

        return system_parameters;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const system_parametersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                key: item.key
            ||
            null
            ,
            
                value: item.value
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                lastUpdatedAt: item.lastUpdatedAt
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const system_parameters = await db.system_parameters.bulkCreate(system_parametersData, { transaction });

        // For each item created, replace relation files
        

        return system_parameters;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const system_parameters = await db.system_parameters.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.key !== undefined) updatePayload.key = data.key;
        
        
        if (data.value !== undefined) updatePayload.value = data.value;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.lastUpdatedAt !== undefined) updatePayload.lastUpdatedAt = data.lastUpdatedAt;
        
        
        updatePayload.updatedById = currentUser.id;

        await system_parameters.update(updatePayload, {transaction});

        
        
        if (data.lastUpdatedByUser !== undefined) {
            await system_parameters.setLastUpdatedByUser(
              
              data.lastUpdatedByUser,
              
              { transaction }
            );
        }
        

        
        

        

        return system_parameters;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const system_parameters = await db.system_parameters.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of system_parameters) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of system_parameters) {
                await record.destroy({transaction});
            }
        });


        return system_parameters;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const system_parameters = await db.system_parameters.findByPk(id, options);

        await system_parameters.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await system_parameters.destroy({
            transaction
        });

        return system_parameters;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const system_parameters = await db.system_parameters.findOne(
            { where },
            { transaction },
        );

        if (!system_parameters) {
            return system_parameters;
        }

        const output = system_parameters.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.lastUpdatedByUser = await system_parameters.getLastUpdatedByUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'lastUpdatedByUser',
        
        where: filter.lastUpdatedByUser ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lastUpdatedByUser.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.lastUpdatedByUser.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'system_parameters',
                        'key',
                        filter.key,
                    ),
                };
            }
            
            if (filter.value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'system_parameters',
                        'value',
                        filter.value,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'system_parameters',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.lastUpdatedAtRange) {
                const [start, end] = filter.lastUpdatedAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    lastUpdatedAt: {
                    ...where.lastUpdatedAt,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    lastUpdatedAt: {
                    ...where.lastUpdatedAt,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.system_parameters.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'system_parameters',
                        'key',
                        query,
                    ),
                ],
            };
        }

        const records = await db.system_parameters.findAll({
            attributes: [ 'id', 'key' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['key', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.key,
        }));
    }

    
};

